<?php

/*********************************************************************

 メディア一括表示プラグイン (2012/11/26)

 Copyright(C) 2009-2012 freo.jp

*********************************************************************/

/* メイン処理 */
function freo_page_media_all()
{
	global $freo;

	//置換用ディレクトリ名取得
	$media_all_names = array();
	$directory_names = explode("\n", $freo->config['plugin']['media_all']['directory_names']);

	foreach ($directory_names as $directory_name) {
		if (!$directory_name) {
			continue;
		}

		list($id, $text) = explode(',', $directory_name, 2);

		$media_all_names[$id] = $text;
	}

	//メディア取得
	$media_alls = freo_page_media_all_get_medias(FREO_FILE_DIR . 'medias/');

	//データ割当
	$freo->smarty->assign(array(
		'token'           => freo_token('create'),
		'media_alls'      => $media_alls,
		'media_all_names' => $media_all_names
	));

	return;
}

/* メディア取得 */
function freo_page_media_all_get_medias($path)
{
	global $freo;

	$files = array();

	if (!file_exists($path)) {
		return $files;
	}

	if ($dir = scandir($path)) {
		natcasesort($dir);

		$tmp_directories = array();
		$tmp_files       = array();

		foreach ($dir as $data) {
			if ($data == '.' or $data == '..') {
				continue;
			}

			if (is_dir($path . $data)) {
				$tmp_directories[] = $data;
			} elseif (is_file($path . $data)) {
				$tmp_files[] = $data;
			}
		}

		$dir = array_merge($tmp_files, $tmp_directories);
	}

	foreach ($dir as $data) {
		if ($data == '.' or $data == '..') {
			continue;
		}
		if (is_dir($path . $data)) {
			$results = freo_page_media_all_get_medias($path . $data . '/');

			if (!empty($results)) {
				$files = array_merge($files, $results);
			}

			$files[$path . $data . '/'] = array(
				'id'        => $path . $data . '/',
				'path'      => $path,
				'name'      => $data,
				'type'      => 'directory',
				'width'     => 0,
				'height'    => 0,
				'size'      => 0,
				'thumbnail' => array(),
				'memo'      => null
			);
		} elseif (is_file($path . $data)) {
			list($file_width, $file_height, $file_size) = freo_file($path . $data);

			$thumbnail_path = preg_replace('/^' . preg_quote(FREO_FILE_DIR . 'medias/', '/') . '/', FREO_FILE_DIR . 'media_thumbnails/', $path);

			if (is_file($thumbnail_path . $data)) {
				list($thumbnail_width, $thumbnail_height, $thumbnail_size) = freo_file($thumbnail_path . $data);

				$thumbnail = array(
					'id'     => $thumbnail_path . $data,
					'path'   => $thumbnail_path,
					'name'   => $data,
					'type'   => 'file',
					'width'  => $thumbnail_width,
					'height' => $thumbnail_height,
					'size'   => $thumbnail_size
				);
			} else {
				$thumbnail = array();
			}

			$memo_path = preg_replace('/^' . preg_quote(FREO_FILE_DIR . 'medias/', '/') . '/', FREO_FILE_DIR . 'media_memos/', $path);

			if (is_file($memo_path . $data . '.txt')) {
				$memo = file_get_contents($memo_path . $data . '.txt');

				if ($memo === false) {
					freo_error('ファイル ' . $memo_path . $data . '.txt' . ' を読み込めません。');
				}
			} else {
				$memo = null;
			}

			$files[$path . $data] = array(
				'id'        => $path . $data,
				'path'      => $path,
				'name'      => $data,
				'type'      => 'file',
				'width'     => $file_width,
				'height'    => $file_height,
				'size'      => $file_size,
				'thumbnail' => $thumbnail,
				'memo'      => $memo
			);
		}
	}

	return $files;
}

?>
